package org.kisti.htc.myproxy;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
//import javax.swing.KeyStroke;

import org.globus.gsi.CertUtil;
import org.globus.gsi.GSIConstants;
import org.globus.gsi.GlobusCredential;
import org.globus.gsi.OpenSSLKey;
import org.globus.gsi.X509ExtensionSet;
import org.globus.gsi.bc.BouncyCastleCertProcessingFactory;
import org.globus.gsi.bc.BouncyCastleOpenSSLKey;
import org.globus.gsi.gssapi.GlobusGSSCredentialImpl;
//import org.globus.gsi.gssapi.auth.IdentityAuthorization;
import org.globus.myproxy.CredentialInfo;
import org.globus.myproxy.InfoParams;
import org.globus.myproxy.MyProxy;
import org.globus.tools.ui.proxy.GridProxyDialog;
import org.globus.tools.ui.proxy.MyproxyDialog;
import org.globus.tools.ui.proxy.MyproxyGUI;
import org.globus.tools.ui.util.JJPanel;
import org.globus.tools.ui.util.UITools;
import org.globus.util.Util;
import org.gridforum.jgss.ExtendedGSSManager;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;
import org.ietf.jgss.GSSManager;


public class HTCaaS_Proxy extends MyproxyGUI implements ActionListener,
WindowListener {
	   /**
		 * sss
		 */
		private static final long serialVersionUID = 1L;

		public static final int FRAME_WIDTH = 600;

	    public static final int FRAME_HEIGHT = 240;

	    public MyProxy myproxy;
	    private final static String TRUSTED_CERT_PATH = "/.globus/certificates";
	    
	    //private JTabbedPane tabPane = null;
	    
	    private JTextField usernameTF = new JTextField(15);

	    private JPasswordField passwordTF = new JPasswordField(15);

	    private JButton createButton, sendButton, killLocButton, killRemButton, infoButton, logonButton;
	    
	    private JButton infoExitButton;

	    private boolean runAsApplication = true;
	    
	    protected JTextField outputField;
	    protected JLabel outputFieldLabel;
	    protected static final String outputFieldString = "Output";
	    protected static final String outputFieldProperty = "Output";

	    protected JCheckBox trustRootsCheckBox;
	    protected static final String trustRootsProperty = "TrustRoots";
	    protected static final String trustRootsPropertyYes = "yes";
	    protected static final String trustRootsPropertyNo = "no";
	    
	    protected JTextArea statusTextArea;
	    protected JScrollPane statusScrollPane;

	    private GlobusCredential gridProxy = null;

	    private GSSCredential credential = null;
	    
	    private String myproxyPassword = "";
	   
	    /**
	     * Create the interface
	     */
	    public HTCaaS_Proxy() {

	        // set up GUI
	        setTitle("HTCaaS_Myproxy Tool");

	        setSize(FRAME_WIDTH, FRAME_HEIGHT);

	        addWindowListener(this);

	        Container contentPane = this.getContentPane();

	        JMenuBar menuBar = new JMenuBar();
	        setJMenuBar(menuBar);
	  
	        JMenu fileMenu = new JMenu("File");  // 1st
	        menuBar.add(fileMenu);

	        JMenuItem exitMenuItem = new JMenuItem("Exit");
	        exitMenuItem.addActionListener(this);
	        fileMenu.add(exitMenuItem);

	        JMenu editMenu = new JMenu("Edit");  //2nd
	        menuBar.add(editMenu);

	        JMenuItem cpMenuItem = new JMenuItem("Certificate Properties");
	        cpMenuItem.addActionListener(this);
	        editMenu.add(cpMenuItem);

	        JMenuItem mpMenuItem = new JMenuItem("Myproxy Properties");
	        mpMenuItem.addActionListener(this);
	        editMenu.add(mpMenuItem);
	       
	        JMenu infoMenu = new JMenu("Info"); //3rd
	        menuBar.add(infoMenu);
	                
	        JMenuItem infoMenuItem = new JMenuItem("About..");
	        infoMenuItem.addActionListener(this);
	        infoMenu.add(infoMenuItem);
	        

	        JPanel buttonPanel = new JPanel();
	        // buttonPanel.setLayout(new BorderLayout());

	        JPanel proxyPanel = new JPanel();
	        proxyPanel.setBorder(BorderFactory.createTitledBorder(" Local Proxy "));

	        createButton = new JButton("Create");
	        killLocButton = new JButton("Destroy");
	      

	        createButton.addActionListener(this);
	        killLocButton.addActionListener(this);

	        proxyPanel.add(createButton);
	        proxyPanel.add(killLocButton);

	        JPanel myproxyPanel = new JPanel();
	        myproxyPanel.setBorder(BorderFactory.createTitledBorder(" Myproxy "));

	        sendButton = new JButton("Init");
	        killRemButton = new JButton("Destroy");
	        infoButton = new JButton("Info");
	        logonButton = new JButton("Logon");

	        sendButton.addActionListener(this);
	        killRemButton.addActionListener(this);
	        infoButton.addActionListener(this);
	        logonButton.addActionListener(this);

	        myproxyPanel.add(sendButton);
	        myproxyPanel.add(killRemButton);
	        myproxyPanel.add(infoButton);
	        myproxyPanel.add(logonButton);
	        
	        
	        buttonPanel.add(proxyPanel); // , BorderLayout.WEST);
	        buttonPanel.add(myproxyPanel); // , BorderLayout.EAST);


	        JJPanel mainPanel = new JJPanel();
	        // mainPanel.setBorder(BorderFactory.createEtchedBorder());
	        mainPanel.setInsets(5, 5, 5, 5);
	        mainPanel.setAnchor(GridBagConstraints.EAST);

	        mainPanel.add(new JLabel("Username: "), 0, 0, 1, 1);

	        mainPanel.add(new JLabel("PEM Passphrase: "), 0, 1, 1, 1);

	        mainPanel.setAnchor(GridBagConstraints.WEST);
	        mainPanel.gbc.weightx = 1;
	        mainPanel.setFill(GridBagConstraints.HORIZONTAL);

	        mainPanel.add(usernameTF, 1, 0, 1, 1);

	        usernameTF.addActionListener(this);

	        mainPanel.add(passwordTF, 1, 1, 1, 1);

	        passwordTF.addActionListener(this);


	        String trustRootPath = MyProxyLogon.getTrustRootPath();
	        String existingTrustRootPath = MyProxyLogon.getExistingTrustRootPath();
	        trustRootsCheckBox = new JCheckBox("Write trust roots to "
	                + trustRootPath + ".");
	        //String trustRootsPropVal = properties.getProperty(trustRootsProperty);
	        if (existingTrustRootPath == null
	                || trustRootPath.equals(existingTrustRootPath)) {
	            trustRootsCheckBox.setSelected(true);
	        } else {
	            trustRootsCheckBox.setSelected(false);
	        }
	        trustRootsCheckBox
	                .setToolTipText("Check this box to download the latest CA certificates, certificate revocation lists, and CA signing policy files from MyProxy.");

	 	        
	        contentPane.add(mainPanel, BorderLayout.CENTER);
	        contentPane.add(buttonPanel, BorderLayout.SOUTH);

	        contentPane.add(trustRootsCheckBox, BorderLayout.NORTH);
	        
	    }
	    
	    
	    
	    
	    
		  /**
	     * Event handlers for button panel
	     */
	    public void actionPerformed(ActionEvent evt) {
	    	
	        Object source = evt.getSource();
	        String cmd = evt.getActionCommand();

	        /** make okButton the default input button * */
	        // if( source == passwordTF ) {  source = okButton;
	        // }
	        
	        /* Check menu */
	        if (cmd.equals("Certificate Properties")) {
	            GridProxyDialog gpd = new GridProxyDialog(this.gridProps);
	            UITools.center(this, gpd);
	            gpd.setVisible(true);
	            return;
	        } else if (cmd.equals("Myproxy Properties")) {
	            MyproxyDialog mpd = new MyproxyDialog(this);
	            UITools.center(this, mpd);
	            mpd.setVisible(true); //instead of mpd.show();
	            return;
	        } else if (cmd.equals("Exit")) {
	            this.exit(0);
	            return;
	        } else if (cmd.equals("About..")){
	        	JDialog abt = new JDialog(this);   	 
	        	abt.add(new JLabel("HTCaas!!!"));
	        	abt.add(infoExitButton);
	        	abt.setSize(100, 100);
	        	abt.setBackground(getBackground() );
	        	abt.setVisible(true);
	        	// if(source2==infoExitButton){   this.exit(0); return;  }
	        	return;
	        }

	        /* Check Buttons */
	        if (source == createButton) { // create proxy

	            if (validatePassword()) {
	                if (createProxy(gridProps.getHours())) {
	                    JOptionPane.showMessageDialog(this,
	                            "Succesfully created a proxy in "
	                                    + gridProps.getProxyFile(), "Success",
	                            JOptionPane.PLAIN_MESSAGE);
	                }
	            }

	        } else if (source == sendButton) { // myproxy-init

	            if (validateUsername() && validatePassword()
	                    && validateMyproxyPassword()) {
	                if (createProxy(gridProps.getCredLifetime()))
	                    sendProxy();
	            }

	        } else if (source == killLocButton) { 
	            deleteProxy();
	        } else if (source == killRemButton) {

	            if (validateUsername() && validateMyproxyPassword()) {
	                deleteMyproxy();
	            }

	        } else if (source == infoButton) { //myproxy-info

	        	if (validateUsername() && validatePassword()
	                    && validateMyproxyPassword()) {
	                if (createProxy(gridProps.getCredLifetime()))
	                	 infoProxy();
	                  //TODO hava to make info 
	            }
	            
	        } else if (source == logonButton) { //myproxy-logon

	        	if (validateUsername() && validatePassword()
	                    && validateMyproxyPassword()) {
	                if (createProxy(gridProps.getCredLifetime()))
	                	 logon();
	                  //TODO hava to make info panel
	            }
	            
	        } else{
	            System.err.println("Unidentified event in MyproxyInit" + cmd
	                    + source);
	        }
	    }

	    private boolean validateUsername() {
	        if (usernameTF.getText().trim().equals("")) {
	            JOptionPane.showMessageDialog(this, "Please enter your username.",
	                    "Need More Information", JOptionPane.WARNING_MESSAGE);
	            return false;
	        }
	        return true;
	    }
	    
	    private boolean validatePassword() {
	        if (passwordTF.getPassword().length == 0) {
	            JOptionPane.showMessageDialog(this, "Please enter your password.",
	                    "Need More Information", JOptionPane.WARNING_MESSAGE);
	            return false;
	        }
	        return true;
	    }

	    private boolean validateMyproxyPassword() {
	        if (myproxyPassword.equals("")) {
	            PasswordDialog passDialog = new PasswordDialog(this);
	            UITools.center(this, passDialog);
	           // passDialog.show();
	            passDialog.setVisible(true);
	            return !passDialog.isCanceled();
	        }
	        return true;
	    }

	    public void deleteProxy() {
	        gridProxy = null;
	        if (!gridProps.getProxyFile().equals("")) {
	            File proxyFile = new File(gridProps.getProxyFile());
	            if (proxyFile.exists()) {
	                if (!Util.destroy(proxyFile)) {
	                    JOptionPane.showMessageDialog(this,
	                            "Unable to destroy local proxy", "Error",
	                            JOptionPane.ERROR_MESSAGE);
	                } else {
	                    JOptionPane.showMessageDialog(this,
	                            "Succesfully destroyed proxy in "
	                                    + gridProps.getProxyFile(), "Success",
	                            JOptionPane.PLAIN_MESSAGE);
	                }
	            } else {
	                JOptionPane.showMessageDialog(this, "No proxy exists in "
	                        + gridProps.getProxyFile(), "Information",
	                        JOptionPane.INFORMATION_MESSAGE);
	            }
	        }
	    }

	    public void deleteMyproxy() {
	        if (gridProxy == null)
	            return;

	        try {
	        	
	            myproxy.setHost(gridProps.getMyproxyServer());
	            myproxy.setPort(gridProps.getMyproxyPort());
	            myproxy.setAuthorization(myproxy.getAuthorization());
	        	//XXX
	            myproxy.destroy( new GlobusGSSCredentialImpl(gridProxy,
	                    GSSCredential.INITIATE_AND_ACCEPT), usernameTF.getText()
	                    .trim(), myproxyPassword);
	            JOptionPane.showMessageDialog(this,
	                    "Succesfully destroyed proxy from myproxy server",
	                    "Success", JOptionPane.PLAIN_MESSAGE);
	            return;
	        } catch (Exception e) {
	            JOptionPane.showMessageDialog(this,
	                    "Failed to delete proxy from myproxy server!\n\""
	                            + e.getMessage() + "\"", "Error",
	                    JOptionPane.ERROR_MESSAGE);
	        }
	    }
	    
	    
	    public boolean createProxy(int hours) {      
	        X509Certificate userCert = null;
	        PrivateKey userKey = null;
	        char[] pwd;
	        FileOutputStream out = null;
	        try {
	            userCert = CertUtil.loadCertificate(gridProps.getUserCertFile());

	            if (userCert == null) {
	                JOptionPane.showMessageDialog(this, "Failed to load cert: "
	                        + gridProps.getUserCertFile(), "Error",
	                        JOptionPane.ERROR_MESSAGE);
	                return false;
	            }

	            pwd = passwordTF.getPassword();

	            OpenSSLKey key = new BouncyCastleOpenSSLKey(gridProps
	                    .getUserKeyFile());

	            if (key.isEncrypted()) {
	                key.decrypt(new String(pwd));
	            }

	            userKey = key.getPrivateKey();

	            pwd = null;

	            if (userKey == null) {
	                JOptionPane.showMessageDialog(this,
	                        "Failed to load private key: "
	                                + gridProps.getUserKeyFile(), "Error",
	                        JOptionPane.ERROR_MESSAGE);
	                return false;
	            }

	            BouncyCastleCertProcessingFactory factory = 
	                BouncyCastleCertProcessingFactory
	                .getDefault();

	            int proxyType = (gridProps.getLimited()) ? 
	                GSIConstants.GSI_4_LIMITED_PROXY
	                : GSIConstants.GSI_4_IMPERSONATION_PROXY;

	            X509ExtensionSet extSet = null;

	            gridProxy = factory.createCredential(
	                    new X509Certificate[] { userCert }, userKey, gridProps
	                            .getBits(), hours*3600, proxyType, extSet);

	            if (gridProxy == null) {
	                JOptionPane.showMessageDialog(this, "Failed to create proxy!",
	                        "Error", JOptionPane.ERROR_MESSAGE);
	                return false;
	            }
	            
	            File file = Util.createFile(gridProps.getProxyFile());
	            // set read only permissions
	            if (!Util.setOwnerAccessOnly(gridProps.getProxyFile())) {

	            }
	            out = new FileOutputStream(file);
	            gridProxy.save(out);

	        } catch (Exception e) {
	            e.printStackTrace();
	            JOptionPane
	                    .showMessageDialog(this, "Failed to create proxy!\n\""
	                            + e.getMessage() + "\"", "Error",
	                            JOptionPane.ERROR_MESSAGE);
	            return false;
	        } finally {
	            if (out != null) {
	                try {
	                    out.close();
	                } catch (IOException e) {
	                }
	            }
	        }
	        return true;
	    }

	    public void sendProxy() {

	        if ((gridProxy == null) || (myproxyPassword.equals("")))
	            return;

	        if (myproxyPassword.equals("")) {
	            PasswordDialog passDialog = new PasswordDialog(this);
	            UITools.center(this, passDialog);
	            //passDialog.show();
	            passDialog.setVisible(true);
	        }

	        try {
	        	myproxy = new MyProxy(gridProps.getMyproxyServer(),gridProps.getMyproxyPort());
	        	if(gridProxy.getSubject()!= null){
	        		System.out.println("gridproxy exists!"+gridProxy.getSubject());
	        		//myproxy.setAuthorization(new IdentityAuthorization(gridProxy.getSubject()));
	        	}else { credential = getDefaultCredential();}
	        	//credential = getDefaultCredential();
	//System.out.println("DN: "+gridProxy.getSubject()); //XXX
	//System.out.println("username:"+ usernameTF.getText().trim());
	//System.out.println(myproxy.getAuthorization());

	myproxy.setAuthorization(new org.globus.gsi.gssapi.auth.IdentityAuthorization("/C=KR/O=KISTI/O=GRID/O=KISTI/CN=host/"+gridProps.getMyproxyServer()));
				//PUT !!!
	        	myproxy.put( new GlobusGSSCredentialImpl(gridProxy,
	                    GSSCredential.INITIATE_AND_ACCEPT), usernameTF.getText()
	                    .trim(), myproxyPassword, gridProps.getCredLifetime());
//	        	myproxy.put( credential, usernameTF.getText()
//	                    .trim(), myproxyPassword, gridProps.getCredLifetime());
	            
	        	JOptionPane.showMessageDialog(this,
	                    "Succesfully delegated a proxy to myproxy server",
	                    "Success", JOptionPane.PLAIN_MESSAGE);
	        } catch (Exception e) {
	            JOptionPane.showMessageDialog(this,
	                    "Failed to delegate proxy to myproxy server!\n\""
	                            + e.getMessage() + "\"", "Error",
	                    JOptionPane.ERROR_MESSAGE);
	        }
	        return;
	    }
	    
	    public void infoProxy(){
	    	
	    	 if (gridProxy == null)
	             return;
	    	
	    	 InfoParams infoRequest = new InfoParams();
	         infoRequest.setUserName( usernameTF.getText().trim());
	         infoRequest.setPassphrase("DUMMY-PASSPHRASE");
	         
	         String tmp;
	         
	         try{
	        	 myproxy = new MyProxy(gridProps.getMyproxyServer(),gridProps.getMyproxyPort());
	        	 if(gridProxy.getSubject()!= null){
	        		 //TODO   ServerDN Constant 생성 해줘야함 
	        		 myproxy.setAuthorization(new org.globus.gsi.gssapi.auth.IdentityAuthorization("/C=KR/O=KISTI/O=GRID/O=KISTI/CN=host/"+gridProps.getMyproxyServer()));
	        	 }
	        	 CredentialInfo[] info = myproxy.info(new GlobusGSSCredentialImpl(gridProxy,
	                     GSSCredential.INITIATE_AND_ACCEPT),infoRequest);
	        	 
	        	 System.out.println ("From MyProxy server: " + myproxy.getHost());
	             System.out.println ("Owner: " + info[0].getOwner());
	             for (int i=0;i<info.length;i++) {
	                 tmp = info[i].getName();
	                 System.out.println ((tmp == null) ? "default:" : tmp +":");
	                 System.out.println ("\tStart Time  : " + 
	                                     info[i].getStartTime());
	                 System.out.println ("\tEnd Time    : " + 
	                                     info[i].getEndTime());
	                     
	                 long now = System.currentTimeMillis();
	                 if (info[i].getEndTime() > now) {
	                     System.out.println ("\tTime left   : " +
	                                         Util.formatTimeSec((info[i].getEndTime() - now)/1000));
	                 } else {
	                     System.out.println ("\tTime left   : expired");
	                 }

	                 tmp = info[i].getRetrievers();
	                 if (tmp != null) {
	                     System.out.println ("\tRetrievers  : "+tmp);
	                 }
	                 tmp = info[i].getRenewers();
	                 if (tmp != null) {
	                     System.out.println ("\tRenewers    : "+tmp);
	                 }
	                 tmp = info[i].getDescription();
	                 if (tmp != null) {
	                     System.out.println ("\tDescription : "+tmp);
	                 }
	             }
	        	        	 
	         }catch(Exception e){
	             JOptionPane.showMessageDialog(this,
	                     "Failed to get info from myproxy server!\n\""
	                             + e.getMessage() + "\"", "Error",
	                     JOptionPane.ERROR_MESSAGE);
	         }
	         
	    }
	 
	    protected void logon() {
	    	MyProxyLogon myproxylogon = new MyProxyLogon();
	    	
	        try {
	            myproxylogon.setUsername(usernameTF.getText().trim());
	            myproxylogon.setPassphrase(new String(myproxyPassword));
//	            if (crednameField.getText().length() > 0) {
//	                myproxylogon.setCredentialName(crednameField.getText());
//	            }
//	            myproxylogon
//	                    .setLifetime(Integer.parseInt(lifetimeField.getText()) * 3600);
	            myproxylogon
	            .setLifetime(gridProps.getCredLifetime()* 3600);
	            myproxylogon.setHost(gridProps.getMyproxyServer());
	            myproxylogon.setPort(gridProps.getMyproxyPort());
	            //TODO IMPORTANT!!!
	            // myproxylogon.requestTrustRoots(trustRootsCheckBox.isSelected());
//	            statusTextArea.setText("Connecting to " + myproxylogon.getHost()
//	                    + "...\n");
	            myproxylogon.connect();
	           // statusTextArea.setText("Logging on...\n");
	            myproxylogon.logon();
//	            if (outputField.getText().length() == 0) {
//	                statusTextArea.setText("Logon successful.\n");
//	            } else {
//	                statusTextArea.setText("Getting credentials...\n");
	                myproxylogon.getCredentials();
//	                statusTextArea.setText("Writing credentials...\n");
//	               myproxylogon.saveCredentialsToFile(outputField.getText());
//	                statusTextArea.setText("Credentials written to "
//	                        + outputField.getText() + ".\n");
//	            }
//	            if (trustRootsCheckBox.isSelected() && myproxylogon.writeTrustRoots()) {
//	                statusTextArea.append("Trust roots written to "
//	                        + myproxylogonLogon.getTrustRootPath() + ".\n");
//	            }
//	            saveProperties();
	        } catch (Exception exception) {
	            exception.printStackTrace();
	            statusTextArea.append("Error: " + exception.getMessage());
	        } finally {
	            try {
	                myproxylogon.disconnect();
	            } catch (Exception e2) {
	            }
	        }
	    }
	    
	    
	    public void setMyproxyPassword(String password) {
	        this.myproxyPassword = password;
	    }
	    
	    public void setRunAsApplication(boolean runAsApplication) {
	        this.runAsApplication = runAsApplication;
	    }

	    public boolean isRunAsApplication() {
	        return this.runAsApplication;
	    }
	    
	    private void exit(int exitValue) {
	        if (this.isRunAsApplication()) {
	            System.exit(exitValue);
	        } else {
	            this.setVisible(false);
	        }
	    }
	    
	    
		   /** * WindowListener Methods ** */
	    @Override
		public void windowActivated(WindowEvent we) {
	    }
	    @Override
	    public void windowClosed(WindowEvent we) {
	    }
	    @Override
	    public void windowDeactivated(WindowEvent we) {
	    }
	    @Override
	    public void windowDeiconified(WindowEvent we) {
	    }
	    @Override
	    public void windowIconified(WindowEvent we) {
	    }
	    @Override
	    public void windowOpened(WindowEvent we) {
	    }
	    @Override
	    public void windowClosing(WindowEvent we) {
	        this.exit(0);
	    }

//	    private static GSSCredential createNewProxy(String userCertFile,
//	            String userKeyFile,
//	            int lifetime, 
//	            String password) {
//
//				X509Certificate [] userCerts = null;
//				PrivateKey userKey = null;  
//				
//				try {
//				OpenSSLKey key = new BouncyCastleOpenSSLKey(userKeyFile);
//				
//				if (key.isEncrypted()) {
//				String prompt = "Enter GRID pass phrase: ";
//				
//				String pwd = password;
//				
//				if (pwd == null) {
//				System.exit(-1);
//				}
//				
//				key.decrypt(pwd);
//				}
//				
//				userKey = key.getPrivateKey();
//				} catch(IOException e) {
//				System.err.println("Error: Failed to load key: " + userKeyFile);
//				System.exit(-1);
//				} catch(GeneralSecurityException e) {
//				System.err.println("Error: Wrong pass phrase");
//				System.exit(-1);
//				}
//				
//				try {
//				userCerts = .loadCertificates(userCertFile);
//				} catch(IOException e) {
//				System.err.println("Error: Failed to load cert: " + userCertFile);
//				System.exit(-1);
//				} catch(GeneralSecurityException e) {
//				System.err.println("Error: Unable to load user certificate: " +
//				userCertFile + " : " + e.getMessage());
//				System.exit(-1);
//				}
//				
//				BouncyCastleCertProcessingFactory factory =
//				BouncyCastleCertProcessingFactory.getDefault();
//				
//				int bits = org.globus.myproxy.MyProxy.DEFAULT_KEYBITS;
//				boolean limited = false;
//				
//				GSIConstants.DelegationType proxyType = (limited) ? 
//				GSIConstants.DelegationType.LIMITED :
//				GSIConstants.DelegationType.FULL;
//				
//				try {
//				X509Credential proxy = 
//				factory.createCredential(userCerts,
//				     userKey,
//				     bits,
//				     lifetime,
//				     proxyType);
//				
//				return new GlobusGSSCredentialImpl(proxy,
//				           GSSCredential.INITIATE_ONLY);
//				
//				} catch (Exception e) {
//				System.err.println("Failed to create a proxy: " + e.getMessage());
//				System.exit(-1);
//				}
//				
//				return null;
//				}
	    
	    private static GSSCredential getDefaultCredential() {
	        GSSManager manager = ExtendedGSSManager.getInstance();
	        try {
	            return manager.createCredential(GSSCredential.INITIATE_ONLY);
	        } catch(GSSException e) {
	            System.err.println("Failed to load default credentials: " + 
	                               e.getMessage());
	            System.exit(-1);
	        }
	        return null;
	    }
	    protected JTabbedPane createTabPane(Color color) {

	        

	        JTabbedPane tabPane = new JTabbedPane();
	        tabPane.setBackground(color);

//	        //if (existsCertificate()) {
//	        // Manage credential panel
//	        manageCredentialPanel = createManageCredentialPanel();
//	        manageCredentialPanel.setBackground(tabPane.getBackground());
//	        tabPane.addTab(MANAGE_CREDENTIALS_LABEL, manageCredentialPanel);
//	        initManageCredentialPanel();
//	        //}
//
//	        // Manage certificate panel
//	        JPanel manageCertificatePanel = createManageCertificatePanel();
//	        manageCertificatePanel.setBackground(tabPane.getBackground());
//	        tabPane.addTab(MANAGE_CERTIFICATES_LABEL, manageCertificatePanel);
//	        initManageCertificatePanel();
//
//	        if (!existsCertificate()) {
//	            tabPane.setSelectedIndex(1);
//	            tabPane.setEnabledAt(0, false);
//	        }

	        return tabPane;
	    }
	    
	    /**
	     * Returns the trusted certificates directory location where
	     * writeTrustRoots() will store certificates.
	     */
	    public static String getTrustRootPath() {
	        String path;

	        path = System.getenv("X509_CERT_DIR");
	        if (path == null) {
	            path = System.getProperty("X509_CERT_DIR");
	        }
	        if (path == null) {
	            path = System.getProperty("user.home") + TRUSTED_CERT_PATH;
	        }
	        return path;
	    }
	    
	    /**
	     * Gets the existing trusted CA certificates directory.
	     *
	     * @return directory path string or null if none found
	     */
	    public static String getExistingTrustRootPath() {
	        String path, GL;

	        GL = System.getenv("GLOBUS_LOCATION");
	        if (GL == null) {
	            GL = System.getProperty("GLOBUS_LOCATION");
	        }

	        path = System.getenv("X509_CERT_DIR");
	        if (path == null) {
	            path = System.getProperty("X509_CERT_DIR");
	        }
	        if (path == null) {
	            path = getDir(System.getProperty("user.home") + TRUSTED_CERT_PATH);
	        }
	        if (path == null) {
	            path = getDir("/etc/grid-security/certificates");
	        }
	        if (path == null) {
	            path = getDir(GL + File.separator + "share" + File.separator
	                    + "certificates");
	        }

	        return path;
	    }

	    private static String getDir(String path) {
	        if (path == null)
	            return null;
	        File f = new File(path);
	        if (f.isDirectory() && f.canRead()) {
	            return f.getAbsolutePath();
	        }
	        return null;
	    }
	    
	    public static void main(String args[]) {
	        for (int i=0;i<args.length;i++) {
	            if (args[i].equals("-help")) {
	                System.out.println("Syntax: java HTCaaS_Proxy");
	                System.exit(0);
	            }
	        }
	        HTCaaS_Proxy mpiFrame = new HTCaaS_Proxy();
	        UITools.center(null, mpiFrame);
	        mpiFrame.setVisible(true);
	    }





		private static String password;

		
	
}
